![Header Image](https://raw.githubusercontent.com/siavash79/AOSPMods/master/.github/AOSP_Mods_Header.png)

This is a mixed Xposed+Magisk module, which is made to allow customizations that are not originally designed in AOSP (Android Open Source Project).

**(Current) Features:**
- Back gesture customization
- (3-Button navigation) Hold back to kill app
- Hide navigation bar
- Light QS Theme
- Vibrate on QS tile tap
- One-Finger QS panel pulldown
- Customize 4G/LTE icon
- Combined signal Icons
- Double-tap to sleep
- Customization on Battery icon style and size
- Configure build number text in QS footer
- Hide fingerprint circle (Pixel 6)
- Lockscreen shortcut customization
- Configure carrier text in lock screen
- Disable screenshot sound
- Power button long-press to toggle Torch
- Double-tap to wake
- Network Monitor
- Statusbar Height
- Statusbar Padding (for phones with left-corner camera)
- Quick Settings Row & Column numbers
- Quick Settings tiles text size
- Internet / Wifi + Cell Tiles
- Navbar pill thickness
- Navbar pill theme
- Keyboard height
- Icon shapes
- Statusbar Icon styles
- Fonts
- Themed Icons
- SystemUI Tuner
- Brightness Slider in Quick QS
- Battery Bar
- Volume Longpress to skip music
- QS Tiles Styles
- Dark Theme Styles
- Longpress on settings icon (in QS) to launch AOSPMods manager
- Expand/Collapse all notifications
- Tablet taskbar (12.1+)
- Music album art on lockscreen
- Dual-tone QS header
- Pin code scramble for extra security
- Disable over-scroll effect
- VoLTE Icon

Of course, this is an ongoing work and the feature list will get longer through time

**Compatibility:**
These mods are designed based on AOSP source code. What does it mean? it means that they are expected to work on Roms (Firmwares) which are built based on fairly unmodified Android source code. This means, mainly, Pixel Phones (3, 4, 4a, 5, 5a, 6), and any other Roms that haven't heavily modified the original Android codes.

- Android 12: Compatible
- Android 12.1 (12L): Compatible
- Andriod 12.1 beta: Compatible
- Android 13 Poorly Compatible (not recommended)


**Prerequisits:**
- Compatible Roms (see above)
- Device Rooted by Magisk 24.2+
- LSPosed (Zygisk Version)


**How to install: (Make sure to read post #2 (FAQ) carefully before you proceed)**
- Install the magisk module
- Reboot (bootloops are not expected)
- You can use AOSPMods app to configure the module

**Credits / Thanks:**
- Android Team
- @topjohnwu for Magisk
- @rovo89 for Xposed
- Team LSPosed
- Team EvolutionX (Specially @kdrag0n). Most of the mods are based on their work
- apsun@github for remote-preferences
- @nijel8 for double-tap to wake

**Translations:**
- @ElTifo Portuguese
- @cracky5322 Chinese Traditional
- @JohnsonRan Chinese Simplified
- @TireX228 Russian
- @ygorigor Romanian
- @krystianokris Polish
- @HofaTheRipper German
- @acuicultor Spanish
- @tomaja18 Spanish
- @n3rd3x3 Spanish

**Brought to you by:**
@siavash79 & @ElTifo
